package com.bcxin.tenant.domain.v5.entities;

import com.bcxin.Infrastructures.entities.EntityAbstract;
import com.bcxin.Infrastructures.entities.IAggregate;
import lombok.AccessLevel;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Table;

@Getter
@Setter(AccessLevel.PROTECTED)
@Table(name = "t_department")
@Entity
public class TDepartmentEntity extends EntityAbstract implements IAggregate {
    @Id
    private String id;
    @Column(name = "name")
    private String name;

    @Column(name = "superior")
    private String superior;

    @Column(name = "domain_id")
    private String domainId;

    @Column(name = "LEVELS")
    private int level;

    protected TDepartmentEntity(){}

    public static TDepartmentEntity create(String id, String name, String superior, String domainId,int level) {
        TDepartmentEntity department = new TDepartmentEntity();
        department.setId(id);
        department.change(name, superior);
        department.setDomainId(domainId);
        department.setLevel(level);

        return department;
    }

    public void change(String name, String superior) {
        this.setName(name);
        this.setSuperior(superior);
    }
}
