package com.bcxin.tenant.domain.v5.services.commands;

import com.bcxin.Infrastructures.commands.CommandAbstract;
import com.bcxin.Infrastructures.enums.CredentialType;
import com.bcxin.tenant.domain.entities.EmployeeEntity;
import lombok.Getter;

import java.util.Collection;

@Getter
public class UserCredentialCommand extends CommandAbstract {
    private final Collection<EmployeeEntity> employees;
    private final String name;
    private final CredentialType credentialType;
    private final String credentialNumber;

    public UserCredentialCommand(Collection<EmployeeEntity> employees, String name, CredentialType credentialType, String credentialNumber) {
        this.employees = employees;
        this.name = name;
        this.credentialType = credentialType;
        this.credentialNumber = credentialNumber;
    }

    public static UserCredentialCommand create(Collection<EmployeeEntity> employees, String name, CredentialType credentialType, String credentialNumber){
        return new UserCredentialCommand(employees,name,credentialType,credentialNumber);
    }
}
